//----------------------------------------------------------------------
//
//  Göran Hasse, Raditex Control AB, gorhas@raditex.nu
//  test program for gtkhhbar
//
//----------------------------------------------------------------------

#include "gtkhhbar.h"

#include <gtk/gtk.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <math.h>

void cb_page_size1(GtkAdjustment *get, GtkAdjustment *set)
{
   // 
   // Set the page size and page increment size of the sample
   // adjustment to the value specified by the "Page Size" scale
   //
   set->page_size = get->value;
   set->page_increment = get->page_increment;

   //
   // Now emit the "changed" signal to reconfigure all the widgets that
   // are attached to this adjustment 
   //
   gtk_signal_emit_by_name(GTK_OBJECT (set), "changed");
}

void cb_page_size2(GtkAdjustment *get, GtkAdjustment *set)
{
   //
   // Set the page size and page increment size of the sample
   // adjustment to the value specified by the "Page Size" scale
   //
  set->value = get->page_size;

  //printf("Value %f\n", get->value );
  //printf("Size  %f\n", get->page_size );
  //printf("Incre %f\n", get->page_increment );

  //
  // Now emit the "changed" signal to reconfigure all the widgets that
  // are attached to this adjustment 
  //
  gtk_signal_emit_by_name(GTK_OBJECT (set), "changed");
}

void cb_page_size3(GtkAdjustment *get, GtkAdjustment *set)
{
   // 
   // Set the page size and page increment size of the sample
   // adjustment to the value specified by the "Page Size" scale
   //
   set->value = get->value;

   // 
   // Now emit the "changed" signal to reconfigure all the widgets that
   // are attached to this adjustment 
   //
   gtk_signal_emit_by_name(GTK_OBJECT (set), "changed");
}

int main(int argc, char *argv[])
{
   GtkAdjustment *adj1, *adj2, *adj3;
   GtkWidget *window, *vbox, *frame1, *frame2, *frame3;
   GtkWidget *hbar1, *hscale1, *hscale2;

   
    gtk_init (&argc, &argv);
    
    // create a new window 
    window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
    gtk_widget_set_usize(GTK_WIDGET(window), 300, 180);
    gtk_window_set_title(GTK_WINDOW(window), "HandleBarTest");
    gtk_container_border_width (GTK_CONTAINER (window), 10);

    gtk_signal_connect(GTK_OBJECT(window), "delete_event",
		       (GtkSignalFunc)gtk_exit, NULL);
    
    vbox  = gtk_vbox_new(FALSE, 5);    
    gtk_container_add(GTK_CONTAINER(window), vbox);
    gtk_container_border_width(GTK_CONTAINER(vbox), 0);


    frame1 = gtk_frame_new( "PageSize" );
    frame2 = gtk_frame_new( "Value" );
    frame3 = gtk_frame_new( "GtkHandelBar");


    //adj2 = GTK_ADJUSTMENT(gtk_adjustment_new(.0, .0, 600.0, 25.0, 25.0, 25.0));
    adj2 = GTK_ADJUSTMENT(gtk_adjustment_new(100, 30, 400, 10, 10, 100));
    hscale1 = gtk_hscale_new(GTK_ADJUSTMENT (adj2));
    gtk_scale_set_value_pos( (GtkScale *) hscale1, GTK_POS_LEFT);
    
    adj3 = GTK_ADJUSTMENT(gtk_adjustment_new(100, 0, 400, 10, 10, 100));
    hscale2 = gtk_hscale_new(GTK_ADJUSTMENT (adj3));
    gtk_scale_set_value_pos( (GtkScale *) hscale2, GTK_POS_LEFT);
    
    adj1 = GTK_ADJUSTMENT(gtk_adjustment_new(100, 0, 300, 10, 10, 100));
    hbar1 = gtk_hhbar_new(GTK_ADJUSTMENT(adj1));

    gtk_widget_set_usize(GTK_WIDGET(hbar1), 150, 10);  

    gtk_signal_connect(GTK_OBJECT(adj2), "value_changed",
		      GTK_SIGNAL_FUNC(cb_page_size1), adj1);

    gtk_signal_connect(GTK_OBJECT(adj3), "value_changed",
		      GTK_SIGNAL_FUNC(cb_page_size3), adj1);

    gtk_signal_connect(GTK_OBJECT(adj1), "value_changed",
		      GTK_SIGNAL_FUNC(cb_page_size2), adj2);

    gtk_signal_connect(GTK_OBJECT(adj1), "value_changed",
		      GTK_SIGNAL_FUNC(cb_page_size3), adj3);

    //gtk_box_pack_start(GTK_BOX(vbox), hbar1, TRUE, TRUE, 0);


    gtk_box_pack_start(GTK_BOX(vbox), frame3, TRUE, TRUE, 0 );
    gtk_box_pack_start(GTK_BOX(vbox), frame1, TRUE, TRUE, 0 );
    gtk_box_pack_start(GTK_BOX(vbox), frame2, TRUE, TRUE, 0 );

    gtk_container_add(GTK_CONTAINER(frame3), hbar1);
    gtk_container_add(GTK_CONTAINER(frame1), hscale1);
    gtk_container_add(GTK_CONTAINER(frame2), hscale2);

    //gtk_box_pack_start(GTK_BOX(frame1), hscale1, TRUE, TRUE, 0 );
    //gtk_box_pack_start(GTK_BOX(frame2), hscale2, TRUE, TRUE, 0 );

    gtk_widget_show_all(window);
    
    gtk_main();
    return(0);
}
//----------------------------------------------------------------------
// EOF
//----------------------------------------------------------------------

